DevExtreme Angular - TypeScript Support
TypeScript is a primary language for Angular development. This help topic outlines additional TypeScript specifics related to development with DevExtreme components.
Component Specific Types
To get component-specific types, import the DxComponentTypes declaration where Component is the component name:
import { Component } from '@angular/core';
import { DxDateBoxTypes } from 'devextreme-angular/ui/date-box';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.css']
})
export class AppComponent {
dateType: DxDateBoxTypes.DateType = "datetime";
}
<dx-date-box ...
[type]="dateType"
>
</dx-date-box>If you need the same type for multiple components, you can import that type from the common submodule:
// In the sample below, ValidationRule is imported for each component:
import { Component } from '@angular/core';
import { DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import { DxFormTypes } from 'devextreme-angular/ui/form';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.css']
})
export class AppComponent {
dataGridValidationRule: DxDataGridTypes.ValidationRule;
formValidationRule: DxFormTypes.ValidationRule;
}
// In the sample below, ValidationRule is imported from the common submodule:
import { Component } from '@angular/core';
import { ValidationRule } from 'devextreme/common';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.css']
})
export class AppComponent {
dataGridValidationRule: ValidationRule;
formValidationRule: ValidationRule;
}Generics Usage
DevExtreme supports Generics for properties and methods that operate internal data. You can use Generics inside event handlers and to define instances of data-aware components like DataGrid:
import { Component, ViewChild } from '@angular/core';
import { DxDataGridComponent, DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import { Employee } from './data';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.css']
})
export class AppComponent {
@ViewChild(DxDataGridComponent) dataGrid!: DxDataGridComponent<Employee, number>;
onEditorPreparing(e: DxDataGridTypes.EditorPreparingEvent<Employee, number>) {
if (e.dataField === 'LastName' && e.parentType === 'dataRow') {
e.editorOptions.disabled = e.row?.data && e.row?.data.FirstName === '';
}
}
onButtonClick() {
const keys: number[] = this.dataGrid.instance.getSelectedRowKeys();
}
}
<dx-button
text="Get Selected Keys"
(onClick)="onButtonClick()"
>
</dx-button>
<dx-data-grid ...
(onEditorPreparing)="onEditorPreparing($event)"
>
</dx-data-grid>

DevExtreme Vue - TypeScript Support
DevExtreme Vue components are supplied with TypeScript declarations. Strict typing allows you to catch bugs at earlier stages and use features like code completion and automated refactoring.
The following code shows an example of using TypeScript with DevExtreme components in a Vue application:
<template>
<div>
<DxList :items="items" ref="list">
<template #item="{data}">
<Item :text="data.text" />
</template>
</DxList>
</div>
</template>
<script lang='ts'>
import { Component, Vue } from 'vue-property-decorator';
import { DxList } from 'devextreme-vue/list';
import Item from './components/Item.vue';
interface IListItemProps {
text: string;
}
@Component({
components: {
DxList,
Item
}
})
export default class App extends Vue {
public $refs: Vue['$refs'] & {
list?: DxList,
} = {};
public items: IListItemProps[] = [
{ text: 'Item 1' },
{ text: 'Item 2' },
{ text: 'Item 3' }
];
}
</script>
<template>
<div @click="addCounter">
{{text}} was clicked {{counter}} times
</div>
</template>
<script lang='ts'>
import { Component, Prop, Vue } from 'vue-property-decorator';
@Component
export default class Item extends Vue {
@Prop() public text!: string;
public counter: number = 0;
public addCounter() {
this.counter = this.counter + 1;
}
}
</script>See Also
Component Specific Types
To get component-specific types, import the DxComponentTypes declaration where Component is the component name:
<template>
<DxDateBox :type="dateType" />
</template>
<script setup lang="ts">
import DxDateBox from "devextreme-vue/date-box";
import type { DxDateBoxTypes } from "devextreme-vue/date-box";
const dateType: DxDateBoxTypes.DateType = "datetime";
</script>If you need the same type for multiple components, you can also import this type from common submodule:
// In the sample below, ValidationRule is imported for each component:
import { DxDataGridTypes } from 'devextreme-vue/data-grid';
import { DxFormTypes } from 'devextreme-vue/form';
const dataGridValidationRule: DxDataGridTypes.ValidationRule;
const formValidationRule: DxFormTypes.ValidationRule;
// In the sample below, ValidationRule is imported from the common submodule:
import { ValidationRule } from 'devextreme-vue/common';
const dataGridValidationRule: ValidationRule;
const formValidationRule: ValidationRule;Generics Usage
DevExtreme supports Generics for properties and methods that operate internal data. You can use Generics inside event handlers and to define instances of data-aware components like DataGrid:
<template>
<div>
<DxButton
text="Disable DataGrid"
@click="onButtonClick"
/>
<DxDataGrid
:data-source="dataSource"
ref="dataGridRef"
@editor-preparing="onEditorPreparing"
>
</DxDataGrid>
</div>
</template>
<script setup lang="ts">
import { ref } from "vue";
import { DxDataGrid } from "devextreme-vue/data-grid";
import { DxButton } from "devextreme-vue/button";
import type { DxDataGridTypes } from "devextreme-vue/data-grid";
import type dxDataGrid from 'devextreme/ui/data_grid';
import type { Employee } from '../data';
const dataGridRef = ref<DxDataGrid>();
function onButtonClick() {
const dataGridInstance = dataGridRef.value?.instance! as dxDataGrid<Employee, number>;
dataGridInstance.option("disabled", true);
}
function onEditorPreparing(e: DxDataGridTypes.EditorPreparingEvent<Employee, number>) {
if (e.dataField === 'LastName' && e.parentType === 'dataRow') {
e.editorOptions.disabled = e.row?.data?.FirstName === '';
}
}
</script>

DevExtreme React - TypeScript Support

DevExtreme React components are supplied with TypeScript declarations. Strict typing allows you to catch bugs at earlier stages and use features like code completion and automated refactoring.

The following code shows an example of using TypeScript with DevExtreme components:

App.tsx
import React, { useState } from 'react';
import List from 'devextreme-react/list';
import 'devextreme/dist/css/dx.light.css';

interface IListItemProps {
    text: string;
}

const items: IListItemProps[] = [
    { text: "Item 1" },
    { text: "Item 2" },
    { text: "Item 3" }
];

const Item: React.FC<IListItemProps> = (props) => {
    const [counter, setCounter] = useState<number>(0);

    const addCounter = () => {
        setCounter(counter + 1);
    };

    return (
        <div onClick={addCounter}>
        {props.text} was clicked {counter} times
        </div>
    );
};

const App: React.FC = () => {
    return (
        <List items={items} itemRender={(props: any) => <Item {...props.data} />} />
    );
};

export default App;

Component-Specific Types

To get component-specific types, import the ComponentTypes declaration where Component is the component name:

App.tsx
import DateBox, { DateBoxTypes } from 'devextreme-react/date-box';

const dateType: DateBoxTypes.DateType = 'datetime';

function App() {
    return (
        <DateBox type={dateType} />
    );
}
</script>

If you need the same type for multiple components, you can also import this type from common submodule:

App.tsx
// In the sample below, ValidationRule is imported for each component:

import { DataGridTypes } from 'devextreme-react/data-grid';
import { FormTypes } from 'devextreme-react/form';

const dataGridValidationRule: DataGridTypes.ValidationRule;
const formValidationRule: FormTypes.ValidationRule;

// In the sample below, ValidationRule is imported from the common submodule:

import { ValidationRule } from 'devextreme-react/common';

const dataGridValidationRule: ValidationRule;
const formValidationRule: ValidationRule;

Templates can include complex template data as an argument. To define types for such templates, import the ComponentTypes declaration and find the type that ends with TemplateData:

App.tsx
import DataGrid, { DataGridTypes } from 'devextreme-react/data-grid';
import Calendar, { CalendarTypes } from 'devextreme-react/calendar';

// A rendering function
const gridCell = (data: DataGridTypes.ColumnCellTemplateData) => {
    return <span>Custom text</span>;
}

// A component
const CustomCell = ({ data }: { data: CalendarTypes.CellTemplateData }) => {
    const { text, view } = data;
    return <span>{ text }</span>;
}

export default App() {
    return (
        <React.Fragment>
            <DataGrid>
                <Column cellRender={gridCell} />
            </DataGrid>
            <Calendar cellComponent={CustomCell} />
        </React.Fragment>
    );
}

Generics Usage

DevExtreme supports Generics for properties and methods that operate internal data. You can use Generics inside event handlers and to define instances of data-aware components like DataGrid:

App.tsx
import { useRef } from 'react';
import service, { Employee } from './data';
import DataGrid, { DataGridTypes } from 'devextreme-react/data-grid';
import Button from 'devextreme-react/button';

function onEditorPreparing(e: DataGridTypes.EditorPreparingEvent<Employee, number>) {
    if (e.dataField === 'LastName' && e.parentType === 'dataRow') {
        e.editorOptions.disabled = e.row?.data && e.row?.data.FirstName === '';
    }
}

function App() {
    const dataGrid = useRef<DataGrid<Employee, number>>(null);

    const onButtonClick = () => {
        const dataGridInstance = dataGrid.current!.instance;
        dataGridInstance.option("disabled", true);
    }

    return (
        <Button
            text={"Disable DataGrid"}
            onClick={onButtonClick}
        />
        <DataGrid<Employee, number>
            ref={dataGrid}
            onEditorPreparing={onEditorPreparing}
            dataSource={dataSource}>
        </DataGrid>
    );
    }

export default App;